#!/usr/bin/python
# -*- coding: UTF-8 -*-
import pygtk
pygtk.require("2.0")
import gtk
import os# pour les manip de noms de fichiers
#import glob

import subprocess #pour la résolution de l'écran'


## variables globales
dossier_rech=''
dossier_racine='/home/yves/Documents/textes/'

dossiers_classes = {'Seconde': 'seconde/nouv_prog/', 'BTS': 'bts/','BTS AEA':'bts/aea/','BTS Géomètres':'bts/geometre/', 'BTS Géomètres Apprentis':'bts/geometre_apprentis/','BTS AEA':'bts/aea/','BTS industriels':'bts/industriels/','Tous':'/'}

classes = ['Seconde', 'BTS AEA', 'BTS Géomètres', 'BTS Géomètres Apprentis']

pasderelief=gtk.ReliefStyle(2)# pour la valeur GTK_RELIEF_NONE




# détection de la résolution de l'écran
# source : sergeG75018 ( http://forum.ubuntu-fr.org/viewtopic.php?id=1006221)
p1 = subprocess.Popen(args=["xrandr"],stdout=subprocess.PIPE)
p2 = subprocess.Popen(args=["grep",'*'],stdin=p1.stdout,stdout=subprocess.PIPE)
p1.stdout.close()
resolution = p2.communicate()[0].split()[0]
p2.stdout.close()
resol_h,resol_v = map(float,resolution.split("x"))

min_scroll_v=int(resol_v*0.2-35)# pour que 900->140 et 600->85
max_scroll_v=int(resol_v*0.5-100)# pour que 900->350 et 600->200, taille des fenêtres de défilement quand on choisit une classe en particulier
min_scroll_h=int(resol_h*0.2+10)# pour que 800->170 et 1440->290
max_scroll_h=int(resol_h*0.5-100)# pour que 800->300 et 1440->600


liste_scrolls=list()
liste_bt_agrandir=list()
liste_boites_classes=list()
liste_nb_sous_dossiers=list()
liste_sous_dossiers_supp=list()
liste_emplacements=[]#emplacements des sous-dossiers d'indice >3
liste_boites_derniers_sous_dossiers=list()

agrandi=False

##

class Profmath:
	def __init__(self):
		self.interface = gtk.Builder()
		self.interface.add_from_file('test.glade')
		self.Fenetre = self.interface.get_object("Fenetre")
		self.Fenetre.set_icon_from_file('gmd.png')

		numclasse=0
		for classe in classes:
			self.faire_classe(classe,numclasse)
			numclasse+=1
		
		self.Fenetre.show_all()
		self.Fenetre.maximize()
		self.Fenetre.connect('key_press_event', self.on_key_press_event)
#		self.Fenetre.fullscreen()
		self.interface.connect_signals(self)




		

### GESTION DE L'APPUI SUR UNE TOUCHE
	def on_key_press_event(self, widget, event):
		keyname = gtk.gdk.keyval_name(event.keyval)
		if keyname=='F11':
			self.Fenetre.fullscreen()
		if keyname=='Escape':
			self.Fenetre.maximize()
# ICI !!!!

#		print "Key %s (%d) was pressed" % (keyname, event.keyval)







### FONCTIONS LIEES AU LISTING DES FICHIERS

	def on_BoutonTri_clicked(self, widget, boite1, boite2):
	        if boite1.get_visible()==True:
	            boite1.hide()       
        	    boite2.show()
	        else:
	            boite2.hide()
        	    boite1.show()


	def on_BoutonSuite_clicked(self, widget, dossier, numclasse, classe, numsousdossier):
		l = liste_sous_dossiers_supp[numclasse]
		nb = len(l)
		# on ferme la boucle
		if numsousdossier==nb+2:
			numsousdossier=2
		sousdossier = l[numsousdossier-2]

		boite=self.faire_sousdossier_classe(dossier,sousdossier,numclasse,numsousdossier+1,classe,True)

		liste_boites_derniers_sous_dossiers[numclasse].destroy()
		liste_boites_derniers_sous_dossiers[numclasse]=boite
		liste_emplacements[numclasse].pack_start(boite)
		liste_emplacements[numclasse].show_all()

		# remise à sa place du scroll pour qu'il puisse être redimensionné
		liste_scrolls[4*numclasse+3]=liste_scrolls[16]# dernier
		del liste_scrolls[16]
		if agrandi:
			liste_scrolls[4*numclasse+3].set_size_request(max_scroll_h,max_scroll_v)







	def on_BoutonFTP_clicked(self, widget,dossier, nomfichier, classe):
		dic_ftpfree = {'Seconde':'seconde/','BTS AEA':'aea/','BTS Géomètres':'gt/','BTS Géomètres Apprentis':'gefa/','BTS DRB':'drb/'}
		dossier_ftp = dic_ftpfree[classe]+'documents/'
		host = 'ftpperso.free.fr'

		import netrc# récupération des mots de passe dans $HOME/.netrc
		n = netrc.netrc()# par défaut : $HOME/.netrc
		user, account, password = n.authenticators(host)
	
		from ftplib import FTP
		ftp = FTP(host) 
		ftp.login(user,password)
		ftp.sendcmd('CWD '+dossier_ftp)
		fic = open(dossier+'/'+nomfichier, 'rb')
		ftp.storbinary('STOR '+nomfichier, fic)
		ftp.close()





	def on_bt_agrandir_clicked(self,widget,numclasse):
		global agrandi
		for i in range(4):
			if agrandi:liste_boites_classes[i].show()
			else:
				if i<>numclasse :
					liste_boites_classes[i].hide()

		# taille des listes de fichiers
		for i in range(4):
			if agrandi:liste_scrolls[4*numclasse+i].set_size_request(min_scroll_h,min_scroll_v)
			else:liste_scrolls[4*numclasse+i].set_size_request(max_scroll_h,max_scroll_v)


		#modifier l'icone
		bt = liste_bt_agrandir[numclasse]
		image = gtk.Image()
		if agrandi:image.set_from_file('agrandir.png')
		else:image.set_from_file('retrecir.png')
		bt.set_image(image)
#		bt.connect('clicked',self.on_bt_retrecir_clicked,numclasse)

		self.Fenetre.maximize()
		agrandi=not agrandi





	def faire_sousdossier_classe(self,dossier,sousdossier,numclasse,numsousdossier,classe,plusdequatre):
		boiteV1 = gtk.VBox()
		boiteh0=gtk.HBox()
		boiteh0.pack_start(gtk.Label(sousdossier.capitalize()))

		bt_explo = gtk.LinkButton("file://"+dossier+sousdossier+"/")
		image = gtk.image_new_from_stock(gtk.STOCK_OPEN,
gtk.ICON_SIZE_DND)
		bt_explo.set_image(image)
		bt_explo.set_relief(pasderelief)
		boiteh0.pack_start(bt_explo)

		bt_tri = gtk.Button()
		image = gtk.Image()
		image.set_from_file('trier.gif')
		bt_tri.set_image(image)
		bt_tri.set_relief(pasderelief)
		boiteh0.pack_start(bt_tri)

		if plusdequatre:
			bt_suite = gtk.Button()
			image = gtk.image_new_from_stock(gtk.STOCK_MEDIA_FORWARD,
gtk.ICON_SIZE_DND)

#			image = gtk.Image()
#			image.set_from_file('trier.gif')
			bt_suite.set_image(image)
#			bt_suite.set_label('>')
			bt_suite.set_relief(pasderelief)
			bt_suite.connect("clicked", self.on_BoutonSuite_clicked, dossier, numclasse, classe, numsousdossier)

			boiteh0.pack_start(bt_suite)

		boiteV1.pack_start(boiteh0)

		scroll = gtk.ScrolledWindow()
		liste_scrolls.append(scroll)
		scroll.set_size_request(min_scroll_h,min_scroll_v)

		boiteV1.pack_start(scroll)


		# obtention de la liste des fichiers
		sousdossier=dossier+sousdossier

		# source http://diveintopython.adrahon.org/
		fileExtList=['.tex','.odt','.ggb','.eps','.png','.ods','.odp']
		fileList = [os.path.normcase(f)
		for f in os.listdir(sousdossier)]
		L = [os.path.join(sousdossier, f)
		for f in fileList
		if os.path.splitext(f)[1] in fileExtList]
			
		L_alphab = list(L)
		
		#http://www.developpez.net/forums/d907737/autres-langages/python-zope/general-python/lister-fichiers-repertoire-facon-chronologique/
		chrono = lambda v: os.path.getmtime(os.path.join(sousdossier, v))
		L.sort(key = chrono)
		L.reverse()
		L = map(os.path.basename,L)# ou : L = [os.path.basename(f) for f in L]

		L_alphab.sort()
		L_alphab = map(os.path.basename,L_alphab)


		def remplirlistefichiers(boite, dossier, liste):
			boiteV2 = gtk.VBox()
			boiteV3 = gtk.VBox()
			boiteV4 = gtk.VBox()
			boiteV5 = gtk.VBox()
			boite.pack_start(boiteV2)
			boite.pack_start(boiteV3)
			boite.pack_start(boiteV4)
			boite.pack_start(boiteV5)

			for f in liste:
				(nomfichier,ext) = os.path.splitext(f)
		
				boiteV2.pack_start(gtk.Label(nomfichier))

				bt = gtk.LinkButton("file://"+dossier+"/"+f)
				image = gtk.Image()
				image.set_from_file(ext[1:]+'.png')
				bt.set_image(image)
				boiteV3.pack_start(bt)
			
				image = gtk.Image()
				if ext=='.tex' or ext=='.odt':
					bt = gtk.LinkButton("file://"+dossier+'/'+nomfichier+'.pdf')
					image.set_from_file('pdf.png')
					bt.set_image(image)
				else:
					bt = image
					image.set_from_file('vide.png')
				boiteV4.pack_start(bt)

				# publication pour les élèves dans le dossier ad-hoc
				
				bt = gtk.Button()
				image = gtk.Image()
				image.set_from_file('ftp.png')
				bt.set_image(image)
				bt.set_relief(pasderelief)
				bt.connect('clicked',self.on_BoutonFTP_clicked,dossier,nomfichier+'.pdf',classe)
				boiteV5.pack_start(bt)


		boiteV = gtk.VBox()
		# création des boites d'affichage des listes alphabetique ou non 
		boiteH1 = gtk.HBox()
		boiteH2 = gtk.HBox()
		boiteH2.hide()
		boiteV.pack_start(boiteH1)
		boiteV.pack_start(boiteH2)
		scroll.add_with_viewport(boiteV)
		bt_tri.connect("clicked", self.on_BoutonTri_clicked, boiteH1, boiteH2)
		remplirlistefichiers(boiteH1, sousdossier, L)
		remplirlistefichiers(boiteH2, sousdossier, L_alphab)

		return boiteV1

















	def faire_classe(self,classe,numclasse):
##		table_classes = self.interface.get_object('table_classes')

		dossier = dossier_racine+dossiers_classes[classe]

##		boite_classe = gtk.VBox()

		boite_classe = self.interface.get_object('boite_classe'+str(numclasse))##
		
		liste_boites_classes.append(boite_classe)
##		boite_classe.set_border_width(2)



		# entête
		boiteH0 = gtk.HBox()

		boiteH0.pack_start(gtk.Label(classe))

		bt = gtk.LinkButton("file://"+dossier+"progression.html")
		image = gtk.Image()
		image.set_from_file('liste.png')
		bt.set_image(image)
		boiteH0.pack_start(bt)


		bt = gtk.LinkButton("file://"+dossier+"/")
		image = gtk.image_new_from_stock(gtk.STOCK_OPEN,
gtk.ICON_SIZE_DND)
		bt.set_image(image)
		bt.set_relief(pasderelief)
		boiteH0.pack_start(bt)



		
		bt = gtk.Button()
		liste_bt_agrandir.append(bt)		
		image = gtk.Image()
		image.set_from_file('agrandir.png')
		bt.set_image(image)
		bt.set_relief(pasderelief)
		bt.connect('clicked',self.on_bt_agrandir_clicked,numclasse)
		boiteH0.pack_start(bt)

		boite_classe.pack_start(boiteH0)
		# fin entête

		# boites pour l'affichage des sous-dossiers

#		exec('boiteH=self.boite_sous_entete'+str(numclasse)+'=gtk.HBox()')

		boiteH = gtk.HBox()
		boite_classe.pack_start(boiteH)		
		boiteV1 = gtk.VBox()
		boiteV2 = gtk.VBox()

		boiteH.pack_start(boiteV1)
		boiteH.pack_start(boiteV2)


		# lister les sous-dossiers
		sousdossiers = [f
		for f in os.listdir(dossier)
		if os.path.isdir(os.path.join(dossier, f))]
		sousdossiers.sort()

		boiteV1.pack_start(self.faire_sousdossier_classe(dossier,sousdossiers[0],numclasse,0,classe,False))
		boiteV2.pack_start(self.faire_sousdossier_classe(dossier,sousdossiers[1],numclasse,1,classe,False))
		boiteV1.pack_start(self.faire_sousdossier_classe(dossier,sousdossiers[2],numclasse,2,classe,False))

		nb = len(sousdossiers)
		liste_nb_sous_dossiers.append(nb)

		booleen=nb>4
		boite = self.faire_sousdossier_classe(dossier,sousdossiers[3],numclasse,3,classe,booleen)

		liste_boites_derniers_sous_dossiers.append(boite)

		if booleen:# cas où il y a plus de 4 sous-dossiers
			empl = gtk.VBox()
			liste_emplacements.append(empl)
			empl.pack_start(boite)
			boiteV2.pack_start(empl)

			# mettre les noms des sous-dossiers suivants dans une liste
			liste=[sousdossiers[3]]
			for i in range(4,nb):
				liste.append(sousdossiers[i])

			liste_sous_dossiers_supp.append(liste)#2D
		
		else:
			liste_sous_dossiers_supp.append('')
			liste_emplacements.append('')
			boiteV2.pack_start(boite)



#		boite_classe.set_size_request(340,230)
		# calcul de la position de la classe dans le tableau
##		col=numclasse%2
##		ligne=int(numclasse/2)
##		table_classes.attach(boite_classe,col,col+1,ligne,ligne+1)
		
###		


		self.Fenetre.show_all()




### FONCTION LIEE AU LANCEMENT D'APPLICATIONS

	def on_bt_appli_clicked(self, widget):
		appli = gtk.Buildable.get_name(widget)
		appli = appli[3:]
	        os.system(appli)














### FONCTIONS LIEES A LA RECHERCHE DE FICHIERS


	# dossier dans lequel chercher	
	def on_bt_radio_rech_toggled(self,bouton):
		global dossier_rech
		if bouton.get_active():
			dossier_rech = dossiers_classes[bouton.get_label()]
			# relancer la recherche
			entree = self.interface.get_object("entree_recherche")
			if entree.get_text() <> '':
				self.on_entree_recherche_icon_press(entree,'','')



	# recherche de fichiers		
	def on_entree_recherche_icon_press(self, entry, icon_pos='', event=''):
		import commands
		boite_resultats = self.interface.get_object("boite_resultats_recherche")
		exp_res_rech = self.interface.get_object("exp_res_rech")
		
		# vider la boite des résultats précédents
		fils = boite_resultats.get_children()
		for k in fils:
			boite_resultats.remove(k)

		lbl_rech = self.interface.get_object("label_resultats")
		
		chn = 'grep -rn --include="*.tex" "' + entry.get_text() + '" "'+dossier_racine+dossier_rech+'"'

		u=commands.getoutput(chn)
		if u <> '':
			u = u.split("\n")# transformation de la chaine en liste
			# découpage et affichage des résultats
			toto = len(dossier_racine)
			compt=0
			for k in u:
				compt=compt+1
				pos = k.find(":")
				chemin_vers_fichier = k[0:pos]
				(dossier, nomfichier) = os.path.split(chemin_vers_fichier)
				nomfichier = os.path.splitext(nomfichier)[0]
				sousdossier = dossier[toto:]
				suite = k[pos+1:]
				pos = suite.find(":")
				ligne = suite[0:pos]
				suite = suite[pos+1:]
				bt = gtk.LinkButton("file://"+chemin_vers_fichier,nomfichier+' (ligne '+ligne+') dans '+sousdossier)
				bt.set_tooltip_text(suite)
				boite_resultats.pack_start(bt)
#				boite_resultats.pack_start(gtk.LinkButton("file://"+chemin_vers_fichier,nomfichier+' dans '+chemin))
		
			exp_res_rech.set_expanded(True)
			lbl_rech.set_text(str(compt)+' résultats')
		else:
			lbl_rech.set_text('Aucun résultat')
		self.Fenetre.show_all()
	
# A VOIR : gtk.Entry.set_completion


###################################################






	def on_Fenetre_destroy(self, widget):
		gtk.main_quit()

if __name__ == "__main__":
	Profmath()
	gtk.main()
